// Simulationsprogramm fr einen Tempomaten


#include "TEMPOMAT.h"
#int_EXT
EXT_isr()
{

}

#int_TIMER1
TIMER1_isr()
{

}

#int_TIMER0
TIMER0_isr()
{

}

#define		schalter_1 PIN_A1
#define		schalter_2 PIN_A2
#define		schalter_3 PIN_A3
#define		led PIN_A4
#define		triebwerk PIN_A5
#define		poti PIN_A6

bool		tempomatstatus = false;
bool		tempomat_alt = false;
int			tempomatgesch = 0;
int			gesch = 0;
bool		bremse = false;
int			gas = 0;
static int	maxgas = 1023;
static int	maxtempo = 1023;
int			steigung = 0;


void beschleunigen(int GasNeu)
{
	set_adc_channel(GasNeu);
	
	delay_ms(10);					//Triebwerksreaktionszeit
}

void abbremsen(int GasNeu)
{
	set_adc_channel(GasNeu);
	
	delay_ms(10);					//Triebwerksreaktionszeit
}

void checkbremse()
{
	/*Bei Bremsbettigung Tempomat ausschalten,
	da keine weitere Funktion implementiert wird ist der Status der Bremse immer false*/
	bool bremsstatus = input(PIN_A3);
	if(tempomatstatus)
	{
		int i;
		for (i=0; i<10; i++)	
		{
			if (!input(schalter_3))
			{
				return;
			}
		}
									// hier ist also sicher "ein"
		while (input(schalter_3))
		{
			delay_ms(10);
		}							// warte hier, bis einpin wieder hoch
		tempomatstatus = false;
	}
}

void checkgas()
{
	/*Bei vernderung der Gaspedalstellung:
		-	beschleunigen oder reduzieren der Geschwindigkeit,
			wenn der Tempomat ausgeschaltet ist
		-	und ignoriere die Reduzierung der Geschwindigkeit
			wenn der Tempomat eingeschaltet wurde.*/
	int gasstatus = input(poti);
	int geschwindgkeitsstatus = input(poti);
	if(gasstatus == gas)
	{
		return;
	}
	else
	{	
		if(gasstatus > gas)
		{
			beschleunigen(gasstatus);
			gesch = geschwindgkeitsstatus;
			if(tempomatstatus)
			{
				tempomatgesch = gesch;
			}
		}
		else if(tempomatstatus==false)
		{
			abbremsen(gasstatus-1);
		}
		else
		{
			return;
		}
	}
}

void checkgeschwindigkeit()
{
	/*Sollte sich die Geschwindgkeit auf Grund der Steigung gendert haben 
	passe die Geschwindgkeit der tempomatgesch an, falls der Tempomat gesetzt ist*/
	int geschwindgkeitsstatus = input(triebwerk);
	int gasstatus = input(poti);
	if(geschwindgkeitsstatus == gesch || tempomatstatus == false )
	{
		return;
	}
	else
	{
	geschwindgkeitsstatus = gesch;
		if(speed < tempomatgesch && gas < maxgas)
		{
			beschleunigen(gasstatus+1);
		}
		else
		{
			abbremsen(gasstatus-1);
		}
	}
}

void checktempomat_altOn()
{
	/*Tempomat wird eingeschaltet*/
	bool tempomat_altstatus = input(schalter_2);
	if(tempomat_altstatus && tempomatstatus)
	{
		int i;
		for (i=0; i<10; i++)	
		{
			if (!input(schalter_2))
			{
				return;
			}
		}
								// hier ist also sicher "ein"
		while (input(schalter_2))
		{
			delay_ms(10);
		}						// warte hier, bis einpin wieder hoch
		if(tempomatstatus)
		{
			tempomatstatus = false;
		}
		else
		{
			tempomatstatus = true;
		}
	}

}

void checktempomatOn()
{
	/*	-	aktivieren und deaktivieren des Tempomaten
		-	setzen der tempomatgesch auf die aktuelle gesch*/
	bool aktuellertempomatstatus = input(schalter_1);

	if(aktuellertempomatstatus!=tempomatstatus)
	{
		int i;
		for (i=0; i<10; i++)	
		{
			if (!input(schalter_1))
			{
				return;
			}
		}
								// hier ist also sicher "ein"
		while (input(PIN_A4))
		{
			delay_ms(10);
		}						// warte hier, bis einpin wieder hoch
		if(tempomatstatus)
		{
			tempomatstatus = false;
		}
		else
		{
			tempomatstatus = true;
			tempomatgesch = gesch;
		}
	}
}


void main()
{

int16 value;

	setup_adc_ports(sAN0|VSS_VDD);
	setup_adc(ADC_CLOCK_INTERNAL);
	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);
	setup_comparator(NC_NC_NC_NC);
	setup_vref(FALSE);
	enable_interrupts(INT_EXT);
	enable_interrupts(INT_TIMER1);
	enable_interrupts(INT_TIMER0);
	enable_interrupts(GLOBAL);


	set_adc_channel( 0 );

	while(true)
	{
		
		checkbremse();				// wenn die Bremse gedrckt wurde, Tempomat ausschalten
		
		checkgas();					//wenn das Gas verndert wurde
		
		checkgeschwindigkeit();		//Bei nderung der Geschwindigkeit durch Steigung etc.
		
		checktempomat_altOn();		//Bei Aktivierung der Schalterstellung
		
		checktempomatOn();			//Einschalter
		delay_ms(10);
	}
	return;
}